/*
 * db_creator_parameters.cpp
 *
 *  Created on: 2011/04/11
 *      Author: shu
 */

#include "db_creator_parameters.h"
#include "sequence_type.h"
#include "protein_type.h"
#include "dna_type.h"
#include "logger.h"
#include <string>
#include <stdlib.h>
#include <getopt.h>
#include <stdexcept>

DbCreatorParameters::DbCreatorParameters() :
  db_filename_(""), input_filename_(""), max_chunk_sequence_length_(1 << 30), sequence_type_(new ProteinType()), max_cached_offset_(4)
{}

void DbCreatorParameters::SetParameters(int argc, char* argv[]) {
  int c;
  extern char *optarg;
  while ((c = getopt(argc, argv, "i:l:o:t:")) != -1) {
    switch (c) {
    case 'i':
      input_filename_ = optarg;
      break;

    case 'l':
      max_chunk_sequence_length_ = atoi(optarg);
      break;

    case 'o':
      db_filename_ = optarg;
      break;

    case 't':
      if (strcmp(optarg, "p") == 0) {
        sequence_type_ = SequenceTypePtr(new ProteinType());
        max_cached_offset_ = 4;
      } else if (strcmp(optarg, "d") == 0){
        sequence_type_ = SequenceTypePtr(new DnaType());
        max_cached_offset_ = 14;
      } else {
        throw invalid_argument("invalid option, -q is p or d.");
      }
      break;

    default:
      throw invalid_argument("\nTry `ghostx --help' for more information.");
    }
  }
}
